"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTaskGroup = void 0;
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
const os = __importStar(require("os"));
const axios_1 = __importDefault(require("axios"));
const events_1 = require("events");
const log_1 = __importDefault(require("../utils/log"));
const m3u8_1 = require("../utils/m3u8");
const common_1 = require("../utils/common");
const system_1 = require("../utils/system");
const media_1 = require("../utils/media");
const agent_1 = __importDefault(require("../utils/agent"));
const ua_1 = __importDefault(require("../constants/ua"));
const file_concentrator_1 = __importDefault(require("./file_concentrator"));
const m3u8_2 = require("./m3u8");
const actions = __importStar(require("./action"));
const types_1 = require("./types");
function isTaskGroup(c) {
    return !!c.subTasks;
}
exports.isTaskGroup = isTaskGroup;
class Downloader extends events_1.EventEmitter {
    onKeyUpdated({ keyUrls, explicitKeys, saveEncryptionKey }) {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    onTaskOutputFileNaming(chunk, id) {
        if (this.chunkNamingStrategy === types_1.NamingStrategy.MIXED) {
            return `${id.toString().padStart(6, "0")}_${new URL(chunk.url).pathname
                .split("/")
                .slice(-1)[0]
                .slice(17 - 255)}`;
        }
        if (this.chunkNamingStrategy === types_1.NamingStrategy.USE_FILE_SEQUENCE) {
            const ext = (0, common_1.getFileExt)(chunk.url);
            return `${id.toString().padStart(6, "0")}${ext ? `.${ext}` : ""}`;
        }
        return new URL(chunk.url).pathname
            .split("/")
            .slice(-1)[0]
            .slice(10 - 255);
    }
    constructor(m3u8Path, { threads, output, key, verbose, retries, proxy, format, cookies, headers, noMerge, cliMode = false, keep = false, keepEncryptedChunks, chunkNamingStrategy, tempDir, } = {
        threads: 5,
    }) {
        super();
        this.cliMode = false;
        /** 输出目录 */
        this.outputPath = "./output.ts";
        /** 并发数量 */
        this.threads = 5;
        /** HTTP Headers */
        this.headers = {};
        /** 是否打印调试信息 */
        this.verbose = false;
        /** 输出格式 */
        this.format = "ts";
        this.noMerge = false;
        /** 块总长度 */
        this.totalChunkLength = 0;
        /** 已完成的块数量 */
        this.finishedChunkCount = 0;
        /** 已完成的块总长度 */
        this.finishedChunkLength = 0;
        /** 重试数量 */
        this.retries = 5;
        /** 超时时间 */
        this.timeout = 60000;
        /** 块超时时间 */
        this.chunkTimeout = 60000;
        this.proxy = "";
        this.autoGenerateChunkList = true;
        this.encryptionKeys = {};
        this.keepTemporaryFiles = false;
        this.keepEncryptedChunks = false;
        this.chunkNamingStrategy = types_1.NamingStrategy.MIXED;
        this.taskStatusRecord = [];
        this._internal_dropChunksInArchiveMode = false;
        if (threads) {
            this.threads = threads;
        }
        if (output) {
            this.outputPath = output;
        }
        if (tempDir) {
            if (!fs.existsSync(tempDir)) {
                log_1.default.error("Temporary path directory not exists.");
                this.emit("critical-error", new Error("Temporary path directory not exists."));
                return;
            }
            log_1.default.info(`Temporary path sets to ${path.resolve(tempDir)}`);
            this.tempPath = path.resolve(tempDir);
        }
        else {
            this.tempPath = path.resolve(os.tmpdir());
        }
        if (key) {
            this.key = key;
        }
        if (verbose) {
            this.verbose = verbose;
        }
        if (retries) {
            this.retries = retries;
        }
        if (format) {
            this.format = format;
        }
        if (cookies) {
            this.cookies = cookies;
        }
        if (headers) {
            const headerConfigArr = Array.isArray(headers) ? headers : [headers];
            for (const headerConfig of headerConfigArr) {
                for (const h of headerConfig.split("\\n")) {
                    try {
                        const header = /^([^ :]+):(.+)$/.exec(h).slice(1);
                        this.headers[header[0]] = header[1].trim();
                    }
                    catch (e) {
                        log_1.default.warning(`HTTP Headers invalid. Ignored.`);
                    }
                }
            }
        }
        // Apply global custom headers
        axios_1.default.defaults.headers.common = Object.assign(Object.assign(Object.assign(Object.assign({}, axios_1.default.defaults.headers.common), {
            "User-Agent": ua_1.default.CHROME_DEFAULT_UA,
        }), (this.cookies ? { Cookie: this.cookies } : {})), this.headers);
        if (proxy) {
            this.proxy = proxy;
            agent_1.default.setProxy(proxy, {
                allowNonPrefixSocksProxy: true,
            });
        }
        if (noMerge) {
            this.noMerge = noMerge;
            log_1.default.warning("Chunks will not be merged.");
            log_1.default.warning("Temporary files will not be deleted automatically.");
        }
        if (keep) {
            this.keepTemporaryFiles = keep;
            log_1.default.warning("Temporary files will not be deleted automatically.");
        }
        if (keepEncryptedChunks) {
            this.keepEncryptedChunks = keepEncryptedChunks;
            log_1.default.info("Encrypted chunks will not be deleted automatically.");
            if (!this.noMerge) {
                log_1.default.warning(`--keep-encrypted-chunks should be used with --keep.`);
            }
        }
        if (chunkNamingStrategy) {
            this.chunkNamingStrategy = +chunkNamingStrategy;
        }
        this.m3u8Path = m3u8Path;
        if (this.format === "ts" && this.outputPath.endsWith(".mkv")) {
            log_1.default.warning(`Output file name ends with .mkv is not supported in direct muxing mode, auto changing to .ts.`);
            this.outputPath = this.outputPath + ".ts";
        }
        if (!this.noMerge) {
            this.outputPath = (0, common_1.getAvailableOutputPath)(this.outputPath);
            this.fileConcentrator = new file_concentrator_1.default({
                outputPath: this.outputPath,
                taskStatusRecord: this.taskStatusRecord,
                deleteAfterWritten: !this.keepTemporaryFiles,
            });
        }
        this.cliMode = cliMode;
        if (cliMode) {
            if (process.platform === "win32") {
                var rl = require("readline").createInterface({
                    input: process.stdin,
                    output: process.stdout,
                });
                rl.on("SIGINT", function () {
                    // @ts-ignore
                    process.emit("SIGINT");
                });
            }
        }
    }
    /**
     * 初始化 读取m3u8内容
     */
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.loadM3U8();
            this.totalChunkLength = this.m3u8.getTotalChunkLength();
        });
    }
    loadM3U8() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const m3u8 = yield (0, m3u8_1.loadM3U8)({
                    path: this.m3u8Path,
                    retries: this.retries,
                    timeout: this.timeout,
                });
                if (m3u8 instanceof m3u8_2.MasterPlaylist) {
                    const streams = m3u8.streams;
                    const bestStream = streams.sort((a, b) => b.bandwidth - a.bandwidth)[0];
                    log_1.default.info("Master playlist input detected. Auto selecting best quality streams.");
                    log_1.default.debug(`Best stream: ${bestStream.url}; Bandwidth: ${bestStream.bandwidth}`);
                    this.m3u8Path = bestStream.url;
                    this.m3u8 = (yield (0, m3u8_1.loadM3U8)({
                        path: bestStream.url,
                        retries: this.retries,
                        timeout: this.timeout,
                    }));
                }
                else {
                    this.m3u8 = m3u8;
                }
            }
            catch (e) {
                log_1.default.error("Aborted due to critical error.", e);
                this.emit("critical-error", e);
            }
        });
    }
    checkKeys() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.m3u8.encryptKeys.length > 0) {
                const newKeys = this.m3u8.encryptKeys.filter((key) => !this.getEncryptionKey((0, common_1.buildFullUrl)(this.m3u8.m3u8Url, key)));
                if (newKeys.length > 0) {
                    yield this.onKeyUpdated({
                        keyUrls: newKeys,
                        explicitKeys: this.key ? this.key.split(",") : [],
                        m3u8Url: this.m3u8.m3u8Url,
                        saveEncryptionKey: this.saveEncryptionKey.bind(this),
                    });
                }
            }
        });
    }
    /**
     * 退出前的清理工作
     */
    clean() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                log_1.default.info("Starting cleaning temporary files.");
                yield (0, system_1.deleteDirectory)(this.tempPath, this.outputFileList);
            }
            catch (e) {
                log_1.default.warning(`Fail to delete temporary files, please delete manually or execute "minyami --clean" later.`);
            }
        });
    }
    /**
     * 处理块下载任务
     * @param task 块下载任务
     */
    handleTask(task) {
        log_1.default.debug(`Downloading ${task.chunk.url}`);
        const options = {};
        options.timeout = Math.min(((task.retryCount || 0) + 1) * this.chunkTimeout, this.chunkTimeout * 5);
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            log_1.default.debug(`Downloading ${task.filename}`);
            try {
                yield (0, media_1.download)(task.chunk.url, path.resolve(this.tempPath, `./${task.filename}`), options);
                log_1.default.debug(`Downloading ${task.filename} succeed.`);
                if (task.chunk.isEncrypted) {
                    const decryptIV = (0, m3u8_2.isInitialChunk)(task.chunk)
                        ? task.chunk.iv
                        : task.chunk.iv || task.chunk.sequenceId.toString(16);
                    yield (0, media_1.decrypt)(path.resolve(this.tempPath, `./${task.filename}`), path.resolve(this.tempPath, `./${task.filename}`) + ".decrypt", this.getEncryptionKey((0, common_1.buildFullUrl)(this.m3u8.m3u8Url, task.chunk.key)), decryptIV, this.keepEncryptedChunks);
                    log_1.default.debug(`Decrypting ${task.filename} succeed`);
                }
                this.finishedChunkCount++;
                if (!(0, m3u8_2.isInitialChunk)(task.chunk)) {
                    this.finishedChunkLength += task.chunk.length;
                }
                resolve();
            }
            catch (e) {
                log_1.default.warning(`Downloading or decrypting ${task.filename} failed. Retry later. [${e.code ||
                    (e.response ? `${e.response.status} ${e.response.statusText}` : undefined) ||
                    e.message ||
                    e.constructor.name ||
                    "UNKNOWN"}]`);
                log_1.default.debug(e);
                reject(e);
            }
        }));
    }
    handleChunkGroupAction(action) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                switch (action.actionName) {
                    case "ping": {
                        yield actions.ping(action.actionParams);
                    }
                    case "sleep": {
                        yield actions.sleep(action.actionParams);
                    }
                }
                log_1.default.info(`Chunk group action <${action.actionName}> finished.`);
            }
            catch (e) {
                log_1.default.info(`Chunk group action <${action.actionName}> failed.`);
                log_1.default.info(e);
            }
        });
    }
    /**
     * ======================
     * Some hooks for parsers
     * ======================
     */
    saveEncryptionKey(url, key) {
        this.encryptionKeys[url] = key;
    }
    getEncryptionKey(url) {
        return this.encryptionKeys[url];
    }
    setOnKeyUpdated(handler) {
        this.onKeyUpdated = handler;
    }
    /**
     * 计算以块计算的下载速度
     */
    calculateSpeedByChunk() {
        return (this.finishedChunkCount / Math.round((new Date().valueOf() - this.startedAt) / 1000)).toFixed(2);
    }
    /**
     * 计算以视频长度为基准下载速度倍率
     */
    calculateSpeedByRatio() {
        return (this.finishedChunkLength / Math.round((new Date().valueOf() - this.startedAt) / 1000)).toFixed(2);
    }
    setOnTaskOutputFileNaming(namingFunction) {
        this.onTaskOutputFileNaming = namingFunction;
    }
}
exports.default = Downloader;
//# sourceMappingURL=downloader.js.map