import { Agent } from "agent-base";
declare class ProxyAgentHelper {
    proxyAgentInstance: Agent;
    constructor();
    /**
     * Set up proxy server and initialize the proxy agent instance
     * @param proxy
     * @param params
     * @param params.allowNonPrefixSocksProxy Treat proxy server without protocol as socks5 proxy for backward compatibility
     */
    setProxy(proxy: string, { allowNonPrefixSocksProxy }?: {
        allowNonPrefixSocksProxy?: boolean;
    }): void;
    getProxyAgentInstance(): Agent;
    /**
     * Read proxy configuration from environment variables.
     * By default, ALL_PROXY, HTTP_PROXY and HTTPS_PROXY will be used.
     */
    readProxyConfigurationFromEnv(): void;
}
declare const _default: ProxyAgentHelper;
export default _default;
