import { AxiosRequestConfig, AxiosResponse } from "axios";
/**
 * 合并视频文件
 * @param fileList 文件列表
 * @param output 输出路径
 */
export declare function mergeToMKV(fileList?: any[], output?: string): Promise<string>;
export declare function mergeToTS(fileList?: any[], output?: string): Promise<string>;
/**
 * 下载文件
 * @param url
 * @param path
 */
export declare function download(url: string, path: string, options?: AxiosRequestConfig): Promise<void>;
/**
 * Raw Request
 * @param url
 * @param proxy
 */
export declare function requestRaw(url: string, options?: AxiosRequestConfig): Promise<AxiosResponse>;
/**
 * 解密文件
 * @param input
 * @param output
 * @param key in hex
 * @param iv in hex
 */
export declare function decrypt(input: string, output: string, key: string, iv: string, keepEncryptedChunks?: boolean): Promise<void>;
