"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readConfigFile = exports.initMinyamiDirectory = exports.forceDeleteDirectory = exports.deleteEmptyDirectory = exports.deleteDirectory = exports.sleep = exports.exec = void 0;
const util = require("util");
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
const os = __importStar(require("os"));
const log_1 = __importDefault(require("./log"));
exports.exec = util.promisify(require("child_process").exec);
const sleep = (deley) => new Promise((resolve) => setTimeout(resolve, deley));
exports.sleep = sleep;
const deleteDirectory = (directoryPath, fileList = []) => {
    for (const filename of fileList) {
        try {
            fs.unlinkSync(path.resolve(directoryPath, filename));
        }
        catch (e) {
            log_1.default.debug(e);
            log_1.default.warning(`Delete ${path.resolve(directoryPath, filename)} failed, ignored`);
        }
    }
    if (fs.readdirSync(directoryPath).length === 0) {
        fs.rmdirSync(directoryPath);
    }
};
exports.deleteDirectory = deleteDirectory;
const deleteEmptyDirectory = (directoryPath) => {
    if (fs.readdirSync(directoryPath).length === 0) {
        fs.rmdirSync(directoryPath);
    }
};
exports.deleteEmptyDirectory = deleteEmptyDirectory;
const forceDeleteDirectory = (directoryPath) => {
    const fileList = fs.readdirSync(directoryPath);
    for (const filename of fileList) {
        fs.unlinkSync(path.resolve(directoryPath, filename));
    }
    fs.rmdirSync(directoryPath);
};
exports.forceDeleteDirectory = forceDeleteDirectory;
const initMinyamiDirectory = () => {
    const minyamiPath = path.resolve(os.homedir(), "./.minyami/");
    if (!fs.existsSync(minyamiPath)) {
        fs.mkdirSync(minyamiPath);
    }
    return minyamiPath;
};
exports.initMinyamiDirectory = initMinyamiDirectory;
const readConfigFile = () => {
    const minyamiPath = (0, exports.initMinyamiDirectory)();
    const availableConfigFilenames = [".minyamirc", ".minyamirc.json", "minyami.config.json"];
    for (const filename of availableConfigFilenames) {
        const configFilePath = path.resolve(minyamiPath, filename);
        if (fs.existsSync(configFilePath)) {
            try {
                const content = JSON.parse(fs.readFileSync(configFilePath).toString());
                log_1.default.debug(`Config file loaded: ${JSON.stringify(content)}`);
                return content;
            }
            catch (_a) {
                log_1.default.debug(`Config file ${configFilePath} not exists or not valid, skip.`);
            }
        }
    }
    return {};
};
exports.readConfigFile = readConfigFile;
//# sourceMappingURL=system.js.map