import { DownloadTaskItem } from "../core/downloader";
export interface MinyamiTask {
    /** 唯一标识符 */
    id: string;
    /** 临时文件目录 */
    tempPath: string;
    /** m3u8文件路径 */
    m3u8Path: string;
    /** 输出目录 */
    outputPath: string;
    /** 并发数量 */
    threads: number;
    /** Cookie */
    cookies: string;
    /** HTTP Headers */
    headers: Record<string, string>;
    key: string;
    /** 是否打印调试信息 */
    verbose: boolean;
    /** 开始下载时间 */
    startedAt: number;
    /** 已完成的块数量 */
    finishedChunksCount: number;
    /** 已完成的块总长度 */
    finishedChunkLength: number;
    /** 全部块数量 */
    totalChunksCount: number;
    /** 重试次数 */
    retries: number;
    /** 超时时间 */
    timeout: number;
    proxy: string;
    /** 未下载的块 */
    downloadTasks: DownloadTaskItem[];
    /** 全部块 */
    allDownloadTasks: DownloadTaskItem[];
    /** 已完成文件名 */
    finishedFilenames: {
        [index: string]: any;
    };
}
/**
 * Get previous task
 * @param taskId
 */
export declare function getTask(taskId: string): MinyamiTask;
/**
 * Save(add) or update task
 * @param task
 */
export declare function saveTask(task: MinyamiTask): void;
/**
 * Delete task
 * @param taskId
 */
export declare function deleteTask(taskId: string): boolean;
